package view;

import javafx.scene.shape.TriangleMesh;

import java.io.File;
import java.io.FileNotFoundException;
import java.net.URL;
import java.util.Scanner;

public class Custom3dModel {

	private TriangleMesh[] model;

	public static final int PAWN = 0, ROOK = 1, KNIGHT = 2, BISHOP = 3, QUEEN = 4, KING = 5;
	public Custom3dModel() {
		model = new TriangleMesh[6];
		model[PAWN] = objImport("/pawn.obj");
		model[ROOK] = objImport("/rook.obj");
		model[KNIGHT] = objImport("/knight.obj");
		model[BISHOP] = objImport("/bishop.obj");
		model[QUEEN] = objImport("/queen.obj");
		model[KING] = objImport("/king.obj");
	}

	public TriangleMesh get(int id) {
		return model[id];
	}
	private TriangleMesh objImport(String filename) {
		// (o_o) #olivier
		// yes, I had to write my own "Import 3d model" function, because javaFX doesn't have any
		TriangleMesh mesh = new TriangleMesh();
		mesh.getTexCoords().addAll(0,0,0,0, 0, 0);
		mesh.getPoints().addAll(0,0,0);
		try {
			URL url = this.getClass().getResource("/pion.vertice");
			File myObj = new File(url.getPath().replaceAll("%20", " "));
			Scanner myReader = new Scanner(myObj);
			while (myReader.hasNextLine()) {
				String data = myReader.nextLine();
				String[] data2 = data.split(",");
				mesh.getPoints().addAll(
						Float.parseFloat(data2[0]),
						Float.parseFloat(data2[1]),
						Float.parseFloat(data2[2])
				);
			}
			myReader.close();
			URL url2 = this.getClass().getResource("/pion.mesh");
			File myObj2 = new File(url2.getPath().replaceAll("%20", " "));
			Scanner myReader2 = new Scanner(myObj2);
			while (myReader2.hasNextLine()) {
				String data3 = myReader2.nextLine();
				String[] data4 = data3.split(",");
				mesh.getFaces().addAll(
						Integer.parseInt(data4[0]), 0,
						Integer.parseInt(data4[1]), 0,
						Integer.parseInt(data4[2]), 0
				);
			}
			myReader2.close();
		} catch (FileNotFoundException e) {
			System.out.println("An error occurred.");
			e.printStackTrace();
		}
		return mesh;
	}
}
