package view;

import javafx.scene.image.Image;
import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;

public class CustomMaterial {

	private static PhongMaterial[] material;
	public static final int
			BLACK = 0, WHITE = 1, SELECTED = 2, MOVABLE = 3,
			ATTACK = 4, SPECIAL = 5, BOARDBLACK = 6, BOARDWHITE = 7, WOOD = 8;
	private static final int MATERIAL_LENGTH = 9;

	public CustomMaterial() {
		material = new PhongMaterial[MATERIAL_LENGTH];
		material[BLACK] = new PhongMaterial();
		material[BLACK].setDiffuseColor(Color.BLACK);
		material[WHITE] = new PhongMaterial();
		material[WHITE].setDiffuseColor(Color.WHITE);
		material[SELECTED] = new PhongMaterial();
		material[SELECTED].setDiffuseColor(Color.YELLOW);
		material[MOVABLE] = new PhongMaterial();
		material[MOVABLE].setDiffuseColor(Color.GREEN);
		material[ATTACK] = new PhongMaterial();
		material[ATTACK].setDiffuseColor(Color.RED);
		material[SPECIAL] = new PhongMaterial();
		material[SPECIAL].setDiffuseColor(Color.CYAN);
		material[BOARDBLACK] = new PhongMaterial();
		material[BOARDBLACK].setDiffuseColor(Color.grayRgb(64));
		material[BOARDWHITE] = new PhongMaterial();
		material[BOARDWHITE].setDiffuseColor(Color.grayRgb(200));
		material[WOOD] = new PhongMaterial();
		material[WOOD].setDiffuseMap(new Image("/wood.jpg"));

		for(int i = 0 ; i < MATERIAL_LENGTH ; i++) {
			material[i].setSpecularColor(Color.rgb(100, 100, 100));
		}
		material[BLACK].setSpecularColor(Color.WHITE); // more intense reflection for black
	}

	public PhongMaterial get(int type) {
		return material[type];
	}
}
